#include <windows.h>
#include <gl\gl.h>
#include "file_reader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// karaktersorozat beolvassa file-bl
char *textFileRead(char *fileName) 
{
	FILE *fp;
	char *content = NULL;
	int count = 0;

	if (fileName != NULL) 
	{
		fp = fopen(fileName, "rt");

		if (fp != NULL) 
		{
			fseek(fp, 0, SEEK_END);
			count = ftell(fp);
			rewind(fp);

			if (count > 0) 
			{
				content = (char*)malloc(sizeof(char) * (count+1));
				count = fread(content, sizeof(char), count, fp);
				content[count] = '\0';
			}

			fclose(fp);
		}
	}

	return content;
}


// tga kpfjl betltse
bool loadTGA(TextureImage *texture, const char *fileName)			
{    
	GLubyte		TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};	
	GLubyte		TGAcompare[12];								
	GLubyte		header[6];									
	GLuint		bytesPerPixel;								
	GLuint		imageSize;									
	GLuint		temp;										
	GLuint		type=GL_RGBA;								

	FILE *file = fopen(fileName, "rb");						

	if (	file==NULL ||										
		fread(TGAcompare,1,sizeof(TGAcompare),file)!=sizeof(TGAcompare) ||	
		memcmp(TGAheader,TGAcompare,sizeof(TGAheader))!=0				||	
		fread(header,1,sizeof(header),file)!=sizeof(header))				
	{
		if (file == NULL)									
			return false;									
		else
		{
			fclose(file);									
			return false;									
		}
	}

	texture->width  = header[1] * 256 + header[0];			
	texture->height = header[3] * 256 + header[2];			
    
 	if (	texture->width	<=0	||								
		texture->height	<=0	||								
		(header[4]!=24 && header[4]!=32))					
	{
		fclose(file);										
		return false;										
	}

	texture->bpp	= header[4];							
	bytesPerPixel	= texture->bpp/8;						
	imageSize		= texture->width*texture->height*bytesPerPixel;	

	texture->imageData=(GLubyte *)malloc(imageSize);		

	if (	texture->imageData==NULL ||							
		fread(texture->imageData, 1, imageSize, file)!=imageSize)	
	{
		if(texture->imageData!=NULL)						
			free(texture->imageData);						

		fclose(file);										
		return false;										
	}

	for (GLuint i=0; i<int(imageSize); i+=bytesPerPixel)		
	{														
		temp=texture->imageData[i];							
		texture->imageData[i] = texture->imageData[i + 2];	
		texture->imageData[i + 2] = temp;					
	}

	// kp tkrzse fgglegesen
	for (int i = 0; i < (int)(texture->height / 2); i++)
	{
		for (int j = 0; j < texture->width; j++)
		{
			for (int k = 0; k < bytesPerPixel; k++)
			{
				temp = texture->imageData[i * texture->width * bytesPerPixel + j * bytesPerPixel + k];
				texture->imageData[i * texture->width * bytesPerPixel + j * bytesPerPixel + k] = texture->imageData[(texture->height - i - 1) * texture->width * bytesPerPixel + j * bytesPerPixel + k];
				texture->imageData[(texture->height - i - 1) * texture->width * bytesPerPixel + j * bytesPerPixel + k] = temp;
			}
		}
	}

	fclose (file);											

	return true;											
}