#version 400

layout (location = 0) in vec3 VertexPosition;
layout (location = 1) in vec3 VertexNormal;

out vec3 ReflectDir;

uniform bool DrawSkyBox;
uniform vec3 WorldCameraPosition;
uniform mat4 ModelMatrix;
uniform mat4 MVP;


void main()
{
	if ( DrawSkyBox ) 
	{
		ReflectDir = VertexPosition;
	} 
	else 
	{
		vec3 worldPos = vec3(ModelMatrix * vec4(VertexPosition, 1.0));
		vec3 worldNorm = vec3(ModelMatrix * vec4(VertexNormal, 0.0));
		vec3 worldView;

		worldView.x = WorldCameraPosition.x - worldPos.x;
		worldView.y = WorldCameraPosition.y - worldPos.y;
		worldView.z = WorldCameraPosition.z - worldPos.z;

		worldView = normalize(worldView);

		ReflectDir = reflect(-worldView, worldNorm);
	}

	gl_Position = MVP * vec4(VertexPosition, 1.0);
}